/// debug
// V.8 schematics .1 release ...
/// no errors found
///////////////////////////////////////////////////////////////////////////////////////////////
#include "buttonbinarator.h" // this is the header for the whole class
#include "4bit.c" // this is the 4bit nibble portb driver class
#define LOWTOHIGH TRUE // transitional defines
#define HIGHTOLOW FALSE
BIT dbutton[4];   //data from button interrupt cast this is class wide so goes here
// interrupt and detect any change on pins portB b4-b7
#int_rb
void detect_rb_change() {
   int current;
   static int last=0;
   set_tris_b(0xF0);
   current=input_b();
   #if LOWTOHIGH
   if ((!bit_test(last,4))&&(bit_test(current,4))) {dbutton[0]=1;}
   if ((!bit_test(last,5))&&(bit_test(current,5))) {dbutton[1]=1;}
   if ((!bit_test(last,6))&&(bit_test(current,6))) {dbutton[2]=1;}
   if ((!bit_test(last,7))&&(bit_test(current,7))) {dbutton[3]=1;}
   #elif HIGHTOLOW
   if ((!bit_test(current,4))&&(bit_test(last,4))) {dbutton[0]=1;}
   if ((!bit_test(current,5))&&(bit_test(last,5))) {dbutton[1]=1;}
   if ((!bit_test(current,6))&&(bit_test(last,6))) {dbutton[2]=1;}
   if ((!bit_test(current,7))&&(bit_test(last,7))) {dbutton[3]=1;}
   #endif
   last=current;
}
//////////////////////////
// main runtime routine //
//////////////////////////
void main() {
   ///////////////
   // VARIABLES //
   ////////////////////////////////////
   BIT RST,DEVICED,CVCC,newdata,new1;  // this cast isnt class wide and is contained in main
   int button[4]; 
   int8 inreg,outreg,t;
   ///////////////////////// good practice to null the variables/flags
   RST=DEVICED=CVCC=FALSE;
   new1=TRUE;
   button[0]=button[1]=button[2]=button[3]=0;  
   inreg=outreg=t=0;  
   // the registers states can ONLY be read and written after the global interrupts are enabled
   enable_interrupts(GLOBAL);
   // this line takes the value of the bport and moves the position pointer right by 4 to get to the data we need in the byte
   inreg=(input_b()>>0x04);   
   // load eeprom value if no buttons preset on boot if there is then load there snap shot value
   if(inreg==0x00) { inreg=read_eeprom(0x00);newdata=TRUE;} 
   // load the flip flops inital state from the inregister variable loaded above 
   for(t=0;t<=3;){ if(bit_test(inreg,t)) { bit_set(button[t],0);}else { bit_clear(button[t],0);} t++; }
   // enable port B pins 4-7 interrupt on activity //   
   enable_interrupts(INT_RB); 
   // main routine 
   do{
         DEVICED=input(PIN_A1);  // activity on the detect pin  detects if you plug the modded hub into a usb device like a gotek or other pc
         RST=input(PIN_A0); // check for reset 
         if((!DEVICED)&&(new1)) // check if the hub isnt plugged into a gotek or other device pc etc 
         {
             output_high(PIN_A2); 
             inreg=0x00;
             //for(t=0;t<=3;){button[t]=0x00;t++;}
             delay_ms(500);
            // output_low(PIN_A2);
             newdata=FALSE;
             new1=FALSE;  
         }
         if(DEVICED) 
         // when a button is pressed the interrupt will pass a value to the dbutton array this is debounced below and the value loaded on a newdata flag
         // this newdata flag is then reset in the newdata routine below
         {
            outreg=inreg;
            if(dbutton[0]) { button[0]= !button[0]; button[1]=button[2]=button[3]=FALSE; dbutton[0]=FALSE;newdata=TRUE;}
            if(dbutton[1]) { button[1]= !button[1]; button[0]=button[2]=button[3]=FALSE; dbutton[1]=FALSE;newdata=TRUE;}
            if(dbutton[2]) { button[2]= !button[2]; button[0]=button[1]=button[3]=FALSE; dbutton[2]=FALSE;newdata=TRUE;}
            if(dbutton[3]) { button[3]= !button[3]; button[0]=button[1]=button[2]=FALSE; dbutton[3]=FALSE;newdata=TRUE;}
            if(newdata){for(t=0;t<=3;){ if(bit_test(button[t],0)) { bit_set(inreg,t);}else { bit_clear(inreg,t);} t++; }}
            if (!new1){new1=TRUE;} // device detect handler flag 
         }
         if(RST) // reset is used to null the bank all 4 devices become available to the pc
         {
            inreg=outreg=0x00; // null the inreg and out reg values
            write_eeprom(0x00,0x00); // write 00 to the eeprom 
            for(t=0;t<=3;){button[t]=0x00;t++;} // set the button buffer to null
            newdata=TRUE; // set a new data event cycle
         }
         if(!RST)
         { outreg=inreg;  } // if no reset detected then copy over the new value of the buttons 
         if(newdata)
         { 
            output_high(PIN_A2); // turn on the CVCC relay to turn off the supply too the 4 usb cards or devices on the hub 
            write_eeprom(0x00,outreg); // write the new value too the eeprom thats loaded at runtime of bypassed if you hold in the button/bank you want
            delay_ms(500); // delay too allow pc to unbind and bind ? perhaps need adjustment tests to come
            newdata=FALSE; // reset the new data flag
         }
         PORT4BIT_WRITE(outreg); // write the value to the lower b port nibble
         output_low(PIN_A2); // turn off the cvcc interupter relay 
            
   }while(TRUE); // do forever
}
////////////////
// THE END... /////////////////////////////////////////////
// THIS CODE WAS MADE BY SIMEON WEBBER M.C.A 14/08/2018  //
//////////////////////////////////////////////////////////////////////////////////////////
// I USED CCS COMPILER FOR THE MAIN WORK AND QUICKBUILDER FOR THE 4 BITSET PORTB OUTPUT //
//////////////////////////////////////////////////////////////////////////////////////////

